/* audioplayer.c generated by valac, the Vala compiler
 * generated from audioplayer.vala, do not modify */

/*

this is a part of sap
copyright 2008 jezra lickter http://www.jezra.net

sap is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

sap is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sap.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define TYPE_URI_PLAYER (uri_player_get_type ())
#define URI_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_URI_PLAYER, UriPlayer))
#define URI_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_URI_PLAYER, UriPlayerClass))
#define IS_URI_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_URI_PLAYER))
#define IS_URI_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_URI_PLAYER))
#define URI_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_URI_PLAYER, UriPlayerClass))

typedef struct _UriPlayer UriPlayer;
typedef struct _UriPlayerClass UriPlayerClass;
typedef struct _UriPlayerPrivate UriPlayerPrivate;
#define _gst_object_unref0(var) ((var == NULL) ? NULL : (var = (gst_object_unref (var), NULL)))
#define _gst_query_unref0(var) ((var == NULL) ? NULL : (var = (gst_query_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gst_tag_list_free0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_free (var), NULL)))

struct _UriPlayer {
	GObject parent_instance;
	UriPlayerPrivate * priv;
	GstTagForeachFunc handle_tags_delegate;
	gpointer handle_tags_delegate_target;
	GDestroyNotify handle_tags_delegate_target_destroy_notify;
};

struct _UriPlayerClass {
	GObjectClass parent_class;
};

struct _UriPlayerPrivate {
	GstPipeline* pipeline;
	GstElement* src;
	GstElement* decoderbin;
	GstElement* audioconverter;
	GstElement* asink;
	GstElement* volume;
	GstQuery* duration_query;
	GstQuery* position_query;
	char* status_text;
	gint64 position;
	gint64 duration;
	char* track_uri;
};


static gpointer uri_player_parent_class = NULL;

GType uri_player_get_type (void);
#define URI_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_URI_PLAYER, UriPlayerPrivate))
enum  {
	URI_PLAYER_DUMMY_PROPERTY
};
void uri_player_handle_tags (UriPlayer* self, GstTagList* list, const char* tag);
static void _uri_player_handle_tags_gst_tag_foreach_func (GstTagList* list, const char* tag, gpointer self);
void uri_player_build_pipeline (UriPlayer* self);
UriPlayer* uri_player_new (void);
UriPlayer* uri_player_construct (GType object_type);
void uri_player_set_uri (UriPlayer* self, const char* uri);
gboolean uri_player_new_decoded_pad (UriPlayer* self, GstPad* decodebin, gboolean arg1, void* data);
static void uri_player_bus_message (UriPlayer* self, GstMessage* message);
static void _lambda0_ (GstBus* bus, GstMessage* message, UriPlayer* self);
static void __lambda0__gst_bus_message (GstBus* _sender, GstMessage* message, gpointer self);
void uri_player_stop (UriPlayer* self);
void uri_player_play (UriPlayer* self);
void uri_player_pause (UriPlayer* self);
double uri_player_get_volume (UriPlayer* self);
void uri_player_set_volume (UriPlayer* self, double vol);
void uri_player_seek_forward (UriPlayer* self, gint64 seconds);
void uri_player_seek_back (UriPlayer* self, gint64 seconds);
void uri_player_increase_volume (UriPlayer* self, double val);
void uri_player_decrease_volume (UriPlayer* self, double val);
void uri_player_get_duration_info (UriPlayer* self);
static void uri_player_finalize (GObject* obj);


static void g_cclosure_user_marshal_VOID__INT64_INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static void _uri_player_handle_tags_gst_tag_foreach_func (GstTagList* list, const char* tag, gpointer self) {
	uri_player_handle_tags (self, list, tag);
}


UriPlayer* uri_player_construct (GType object_type) {
	UriPlayer * self;
	GstTagForeachFunc _tmp0_;
	char* _tmp1_;
	GstQuery* _tmp2_;
	GstQuery* _tmp3_;
	self = (UriPlayer*) g_object_new (object_type, NULL);
	self->handle_tags_delegate = (_tmp0_ = _uri_player_handle_tags_gst_tag_foreach_func, ((self->handle_tags_delegate_target_destroy_notify == NULL) ? NULL : (self->handle_tags_delegate_target_destroy_notify (self->handle_tags_delegate_target), NULL), self->handle_tags_delegate = NULL, self->handle_tags_delegate_target = NULL, self->handle_tags_delegate_target_destroy_notify = NULL), self->handle_tags_delegate_target = g_object_ref (self), self->handle_tags_delegate_target_destroy_notify = g_object_unref, _tmp0_);
	self->priv->position = (gint64) 0;
	self->priv->duration = (gint64) 0;
	self->priv->status_text = (_tmp1_ = g_strdup (""), _g_free0 (self->priv->status_text), _tmp1_);
	uri_player_build_pipeline (self);
	self->priv->duration_query = (_tmp2_ = gst_query_new_duration (GST_FORMAT_TIME), _gst_query_unref0 (self->priv->duration_query), _tmp2_);
	self->priv->position_query = (_tmp3_ = gst_query_new_position (GST_FORMAT_TIME), _gst_query_unref0 (self->priv->position_query), _tmp3_);
	return self;
}


UriPlayer* uri_player_new (void) {
	return uri_player_construct (TYPE_URI_PLAYER);
}


static gpointer _gst_object_ref0 (gpointer self) {
	return self ? gst_object_ref (self) : NULL;
}


void uri_player_set_uri (UriPlayer* self, const char* uri) {
	GError * _inner_error_;
	char* _tmp0_;
	GstElement* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
	_inner_error_ = NULL;
	self->priv->track_uri = (_tmp0_ = g_strdup (uri), _g_free0 (self->priv->track_uri), _tmp0_);
	gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_NULL);
	{
		gst_bin_remove ((GstBin*) self->priv->pipeline, self->priv->src);
	}
	__finally1:
	{
	}
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->src = (_tmp1_ = gst_element_make_from_uri (GST_URI_SRC, uri, "my_src"), _gst_object_unref0 (self->priv->src), _tmp1_);
	gst_bin_add ((GstBin*) self->priv->pipeline, _gst_object_ref0 (self->priv->src));
	gst_element_link (self->priv->src, self->priv->decoderbin);
}


static void _lambda0_ (GstBus* bus, GstMessage* message, UriPlayer* self) {
	g_return_if_fail (bus != NULL);
	g_return_if_fail (message != NULL);
	uri_player_bus_message (self, message);
}


static void __lambda0__gst_bus_message (GstBus* _sender, GstMessage* message, gpointer self) {
	_lambda0_ (_sender, message, self);
}


void uri_player_build_pipeline (UriPlayer* self) {
	GstPipeline* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	GstElement* _tmp4_;
	GstElement* _tmp5_;
	GstBus* bus;
	g_return_if_fail (self != NULL);
	self->priv->pipeline = (_tmp0_ = GST_PIPELINE ((GstPipeline*) gst_pipeline_new ("pipeline")), _gst_object_unref0 (self->priv->pipeline), _tmp0_);
	self->priv->src = (_tmp1_ = gst_element_factory_make ("fakesrc", "source"), _gst_object_unref0 (self->priv->src), _tmp1_);
	gst_bin_add ((GstBin*) self->priv->pipeline, _gst_object_ref0 (self->priv->src));
	self->priv->decoderbin = (_tmp2_ = gst_element_factory_make ("decodebin", "decoder"), _gst_object_unref0 (self->priv->decoderbin), _tmp2_);
	gst_bin_add ((GstBin*) self->priv->pipeline, _gst_object_ref0 (self->priv->decoderbin));
	g_object_connect ((GObject*) self->priv->decoderbin, "swapped-object-signal::new-decoded-pad", uri_player_new_decoded_pad, self, NULL);
	self->priv->audioconverter = (_tmp3_ = gst_element_factory_make ("audioconvert", "converter"), _gst_object_unref0 (self->priv->audioconverter), _tmp3_);
	gst_bin_add ((GstBin*) self->priv->pipeline, _gst_object_ref0 (self->priv->audioconverter));
	self->priv->volume = (_tmp4_ = gst_element_factory_make ("volume", "vol"), _gst_object_unref0 (self->priv->volume), _tmp4_);
	gst_bin_add ((GstBin*) self->priv->pipeline, _gst_object_ref0 (self->priv->volume));
	self->priv->asink = (_tmp5_ = gst_element_factory_make ("autoaudiosink", "aoutput"), _gst_object_unref0 (self->priv->asink), _tmp5_);
	gst_bin_add ((GstBin*) self->priv->pipeline, _gst_object_ref0 (self->priv->asink));
	gst_element_link (self->priv->audioconverter, self->priv->volume);
	gst_element_link (self->priv->volume, self->priv->asink);
	bus = gst_pipeline_get_bus (self->priv->pipeline);
	gst_bus_add_signal_watch (bus);
	g_signal_connect_object (bus, "message", (GCallback) __lambda0__gst_bus_message, self, 0);
	_gst_object_unref0 (bus);
}


void uri_player_handle_tags (UriPlayer* self, GstTagList* list, const char* tag) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (list != NULL);
	g_return_if_fail (tag != NULL);
	if (tag != NULL) {
		GQuark _tmp3_;
		const char* _tmp2_;
		static GQuark _tmp3__label0 = 0;
		static GQuark _tmp3__label1 = 0;
		static GQuark _tmp3__label2 = 0;
		static GQuark _tmp3__label3 = 0;
		static GQuark _tmp3__label4 = 0;
		static GQuark _tmp3__label5 = 0;
		static GQuark _tmp3__label6 = 0;
		static GQuark _tmp3__label7 = 0;
		_tmp2_ = tag;
		_tmp3_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
		if ((((((_tmp3_ == ((0 != _tmp3__label0) ? _tmp3__label0 : (_tmp3__label0 = g_quark_from_static_string ("artist")))) || (_tmp3_ == ((0 != _tmp3__label1) ? _tmp3__label1 : (_tmp3__label1 = g_quark_from_static_string ("title"))))) || (_tmp3_ == ((0 != _tmp3__label2) ? _tmp3__label2 : (_tmp3__label2 = g_quark_from_static_string ("album"))))) || (_tmp3_ == ((0 != _tmp3__label3) ? _tmp3__label3 : (_tmp3__label3 = g_quark_from_static_string ("channel-mode"))))) || (_tmp3_ == ((0 != _tmp3__label4) ? _tmp3__label4 : (_tmp3__label4 = g_quark_from_static_string ("comment"))))) || (_tmp3_ == ((0 != _tmp3__label5) ? _tmp3__label5 : (_tmp3__label5 = g_quark_from_static_string ("audio-codec")))))
		switch (0) {
			default:
			{
				char* val;
				char* _tmp1_;
				char* _tmp0_ = NULL;
				val = g_strdup ("Unknown");
				gst_tag_list_get_string (list, tag, &_tmp0_);
				val = (_tmp1_ = _tmp0_, _g_free0 (val), _tmp1_);
				g_signal_emit_by_name (self, "tag-parsed", tag, val);
				_g_free0 (val);
				break;
			}
		} else if ((_tmp3_ == ((0 != _tmp3__label6) ? _tmp3__label6 : (_tmp3__label6 = g_quark_from_static_string ("track-number")))) || (_tmp3_ == ((0 != _tmp3__label7) ? _tmp3__label7 : (_tmp3__label7 = g_quark_from_static_string ("bitrate")))))
		switch (0) {
			default:
			{
				guint val = 0U;
				gst_tag_list_get_uint (list, tag, &val);
				break;
			}
		} else
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}


static void uri_player_bus_message (UriPlayer* self, GstMessage* message) {
	GstMessageType t;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	t = message->type;
	switch (t) {
		case GST_MESSAGE_ERROR:
		{
			gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_NULL);
			g_signal_emit_by_name (self, "playing-error");
			break;
		}
		case GST_MESSAGE_EOS:
		{
			gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_NULL);
			g_signal_emit_by_name (self, "finished-playing");
			break;
		}
		case GST_MESSAGE_TAG:
		{
			GstTagList* tag_list;
			GstTagList* _tmp1_;
			GstTagList* _tmp0_ = NULL;
			tag_list = NULL;
			gst_message_parse_tag (message, &_tmp0_);
			tag_list = (_tmp1_ = _tmp0_, _gst_tag_list_free0 (tag_list), _tmp1_);
			gst_tag_list_foreach (tag_list, _uri_player_handle_tags_gst_tag_foreach_func, self);
			_gst_tag_list_free0 (tag_list);
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState state = 0;
			GstState pending = 0;
			gboolean _tmp2_ = FALSE;
			gst_element_get_state ((GstElement*) self->priv->pipeline, &state, &pending, (GstClockTime) 1);
			if (state == GST_STATE_PLAYING) {
				_tmp2_ = TRUE;
			} else {
				_tmp2_ = state == GST_STATE_PAUSED;
			}
			if (_tmp2_) {
				g_signal_emit_by_name (self, "player-status", gst_element_state_get_name (state));
			}
			break;
		}
		default:
		{
			break;
		}
	}
}


gboolean uri_player_new_decoded_pad (UriPlayer* self, GstPad* decodebin, gboolean arg1, void* data) {
	gboolean result = FALSE;
	GstPad* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (decodebin != NULL, FALSE);
	gst_pad_link (decodebin, _tmp0_ = gst_element_get_static_pad (self->priv->audioconverter, "sink"));
	_gst_object_unref0 (_tmp0_);
	result = TRUE;
	return result;
}


void uri_player_stop (UriPlayer* self) {
	g_return_if_fail (self != NULL);
	gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_READY);
}


void uri_player_play (UriPlayer* self) {
	GstState state = 0;
	GstState pending = 0;
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_PLAYING);
	gst_element_get_state ((GstElement*) self->priv->pipeline, &state, &pending, (GstClockTime) 1);
	g_signal_emit_by_name (self, "display-file-path", _tmp0_ = g_strdup_printf ("%s", self->priv->track_uri));
	_g_free0 (_tmp0_);
}


void uri_player_pause (UriPlayer* self) {
	GstState state = 0;
	GstState pending = 0;
	g_return_if_fail (self != NULL);
	gst_element_get_state ((GstElement*) self->priv->pipeline, &state, &pending, (GstClockTime) 1);
	if (state == GST_STATE_PAUSED) {
		uri_player_play (self);
	} else {
		gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_PAUSED);
	}
}


double uri_player_get_volume (UriPlayer* self) {
	double result = 0.0;
	double vol = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	g_object_get ((GObject*) self->priv->volume, "volume", &vol, NULL);
	result = vol;
	return result;
}


void uri_player_set_volume (UriPlayer* self, double vol) {
	g_return_if_fail (self != NULL);
	g_object_set ((GObject*) self->priv->volume, "volume", vol, NULL);
	g_signal_emit_by_name (self, "volume-changed", vol);
}


void uri_player_seek_forward (UriPlayer* self, gint64 seconds) {
	gint64 sec;
	gint64 newloc = 0LL;
	g_return_if_fail (self != NULL);
	sec = seconds * 1000000000;
	newloc = self->priv->position + sec;
	gst_element_seek_simple (self->priv->audioconverter, GST_FORMAT_TIME, GST_SEEK_FLAG_KEY_UNIT | GST_SEEK_FLAG_FLUSH, newloc);
}


void uri_player_seek_back (UriPlayer* self, gint64 seconds) {
	gint64 sec;
	gint64 newloc = 0LL;
	g_return_if_fail (self != NULL);
	sec = seconds * 1000000000;
	if ((self->priv->position - sec) < 0) {
		newloc = (gint64) 0;
	} else {
		newloc = self->priv->position - sec;
	}
	gst_element_seek_simple (self->priv->audioconverter, GST_FORMAT_TIME, GST_SEEK_FLAG_KEY_UNIT | GST_SEEK_FLAG_FLUSH, newloc);
	uri_player_play (self);
}


void uri_player_increase_volume (UriPlayer* self, double val) {
	double newvol = 0.0;
	double vol;
	g_return_if_fail (self != NULL);
	vol = uri_player_get_volume (self);
	newvol = vol + val;
	if (vol >= 1) {
		newvol = (double) 1;
	}
	uri_player_set_volume (self, newvol);
}


void uri_player_decrease_volume (UriPlayer* self, double val) {
	double newvol = 0.0;
	double vol;
	g_return_if_fail (self != NULL);
	vol = uri_player_get_volume (self);
	if ((vol - val) < 0) {
		newvol = (double) 0;
	} else {
		newvol = vol - val;
	}
	uri_player_set_volume (self, newvol);
}


void uri_player_get_duration_info (UriPlayer* self) {
	gboolean duration_result = FALSE;
	gboolean position_result = FALSE;
	GstFormat format;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	format = GST_FORMAT_TIME;
	duration_result = gst_element_query ((GstElement*) self->priv->pipeline, self->priv->duration_query);
	position_result = gst_element_query ((GstElement*) self->priv->pipeline, self->priv->position_query);
	if (duration_result) {
		_tmp0_ = position_result;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gst_query_parse_duration (self->priv->duration_query, &format, &self->priv->duration);
		gst_query_parse_position (self->priv->position_query, &format, &self->priv->position);
		g_signal_emit_by_name (self, "position-duration", self->priv->position, self->priv->duration);
	}
}


static void uri_player_class_init (UriPlayerClass * klass) {
	uri_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UriPlayerPrivate));
	G_OBJECT_CLASS (klass)->finalize = uri_player_finalize;
	g_signal_new ("position_duration", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64_INT64, G_TYPE_NONE, 2, G_TYPE_INT64, G_TYPE_INT64);
	g_signal_new ("finished_playing", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("playing_error", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("tag_parsed", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	g_signal_new ("volume_changed", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	g_signal_new ("player_status", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("display_info", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("display_file_path", TYPE_URI_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void uri_player_instance_init (UriPlayer * self) {
	self->priv = URI_PLAYER_GET_PRIVATE (self);
}


static void uri_player_finalize (GObject* obj) {
	UriPlayer * self;
	self = URI_PLAYER (obj);
	{
		gst_element_set_state ((GstElement*) self->priv->pipeline, GST_STATE_NULL);
	}
	_gst_object_unref0 (self->priv->pipeline);
	_gst_object_unref0 (self->priv->src);
	_gst_object_unref0 (self->priv->decoderbin);
	_gst_object_unref0 (self->priv->audioconverter);
	_gst_object_unref0 (self->priv->asink);
	_gst_object_unref0 (self->priv->volume);
	_gst_query_unref0 (self->priv->duration_query);
	_gst_query_unref0 (self->priv->position_query);
	_g_free0 (self->priv->status_text);
	_g_free0 (self->priv->track_uri);
	(self->handle_tags_delegate_target_destroy_notify == NULL) ? NULL : (self->handle_tags_delegate_target_destroy_notify (self->handle_tags_delegate_target), NULL);
	self->handle_tags_delegate = NULL;
	self->handle_tags_delegate_target = NULL;
	self->handle_tags_delegate_target_destroy_notify = NULL;
	G_OBJECT_CLASS (uri_player_parent_class)->finalize (obj);
}


GType uri_player_get_type (void) {
	static volatile gsize uri_player_type_id__volatile = 0;
	if (g_once_init_enter (&uri_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UriPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) uri_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UriPlayer), 0, (GInstanceInitFunc) uri_player_instance_init, NULL };
		GType uri_player_type_id;
		uri_player_type_id = g_type_register_static (G_TYPE_OBJECT, "UriPlayer", &g_define_type_info, 0);
		g_once_init_leave (&uri_player_type_id__volatile, uri_player_type_id);
	}
	return uri_player_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__INT64_INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT64_INT64) (gpointer data1, gint64 arg_1, gint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT64_INT64 callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64_INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), g_value_get_int64 (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}



